var graphdata = {};
var graphs = null;
var graphcnt = 0;
var realgraphdata = {};
var hwwdata = null;
var SelectedEventElement = null;
var locked = false;
var REASON_UMAX = 1;
var REASON_UMIN = 2;
var REASON_IMAX = 3;
var REASON_UOFF = 4;

//////////////////////////////////
// FUNC: INIT
// DESC: Initalisation
/////////////////////////////////
function initevents() {

	$.get("/lib/events/hww.html", DataReceive);

	$('input:checkbox').change(
		function () {
			$("#loader").show();
			locked = true;
			if ($(this).is(':checked')) {
				AddGraph($(this).val());
			} else {
				UpdateRealGraph();
			}
		});
}

function AddGraph(channel) {
    
    channel = parseInt(channel);
    console.log("Addgraph with channel: " + channel);
    //check if it's allready available
    var art = false;
    for (var x in graphdata) {
        if (graphdata[x].channel === parseInt(channel)) {
            art = true;
        }
    }

    //if it is not there go get it
    if (art === false) {
        console.log("Graph is not available yet");
        //loop through availabe graphs
        for (var x in graphs)
        {
            //if this is the channel where the event occured
            console.log(hwwdata[graphs[x]].Channel);
            if (hwwdata[graphs[x]].Channel === parseInt(channel)) {
                console.log("Request channel data");
                $.getJSON("../../lib/events/mk_hww.html?_hww_nr=" + graphs[x], function (data) {
                    graphcnt++;
                    //add graphdata to the array
                    graphdata[graphcnt] = data;
                    graphdata[graphcnt]['channel'] = parseInt(channel);
                    //add the label to the array
                    graphdata[graphcnt]['label'] = getChannelName(channel);
                    //check if voltage or current

                    if (channel === 1 || channel === 3 || channel === 5 || channel === 7) {
                        graphdata[graphcnt]['yaxis'] = 2;
                    }
                    UpdateRealGraph();
                });
            }
        }
    } else {
        //update realgraphdata
        UpdateRealGraph();
    }
}

function UpdateRealGraph() {
    console.log("Update real graphs");
    realgraphdata = {};
    var gdc = 0;
    for (var x in graphdata) {
        if (graphdata[x].channel === 0 && $('#U1').is(':checked')) {
            realgraphdata[gdc] = graphdata[x];
            gdc++;
        }
        if (graphdata[x].channel === 2 && $('#U2').is(':checked')) {
            realgraphdata[gdc] = graphdata[x];
            gdc++;
        }
        if (graphdata[x].channel === 4 && $('#U3').is(':checked')) {
            realgraphdata[gdc] = graphdata[x];
            gdc++;
        }
        if (graphdata[x].channel === 6 && $('#U4').is(':checked')) {
            realgraphdata[gdc] = graphdata[x];
            gdc++;
        }
        if (graphdata[x].channel === 1 && $('#I1').is(':checked')) {
            realgraphdata[gdc] = graphdata[x];
            gdc++;
        }
        if (graphdata[x].channel === 3 && $('#I2').is(':checked')) {
            realgraphdata[gdc] = graphdata[x];
            gdc++;
        }
        if (graphdata[x].channel === 5 && $('#I3').is(':checked')) {
            realgraphdata[gdc] = graphdata[x];
            gdc++;
        }
        if (graphdata[x].channel === 7 && $('#I4').is(':checked')) {
            realgraphdata[gdc] = graphdata[x];
            gdc++;
        }
        
    }
    
    console.log(graphdata);
    console.log(realgraphdata);
    
    showhww();
}

//////////////////////////////////
// FUNC: DataReceive
// DESC: Creates Event List
/////////////////////////////////
function DataReceive(text) {

    var data = text.split("-NEXT_ARRAY-");
    hwwdata = eval("(" + data[0] + ")");
    evtdata = eval("(" + data[1] + ")");
    evtdata.sort(evtsort);

    for (var i in evtdata) {
        if (i in Array.prototype)
            continue;
        // Umax?
        var tmp = evtdata[i].reason >> 0 & 0xFF;
        if (tmp) {
            evtdata[i].unit = "V";
            evtdata[i].ReasonType = REASON_UMAX;
            evtdata[i].phase = HexToPhase(tmp);
        }
        //Umin?
        var tmp = evtdata[i].reason >> 8 & 0xFF;
        if (tmp) {
            evtdata[i].unit = "V";
            evtdata[i].ReasonType = REASON_UMIN;
            evtdata[i].phase = HexToPhase(tmp);
        }
        var tmp = evtdata[i].reason >> 16 & 0xFF;
        if (tmp) {
            evtdata[i].unit = "A";
            evtdata[i].ReasonType = REASON_IMAX;
            evtdata[i].phase = HexToPhase(tmp);
        }
        var tmp = evtdata[i].reason >> 24 & 0xFF;
        if (tmp) {
            evtdata[i].unit = "V";
            evtdata[i].ReasonType = REASON_UOFF;
            evtdata[i].phase = HexToPhase(tmp);
        }
    }

    var SelectElement = 0;
    if (/show=([0-9]+)/.exec(document.location.search))
        SelectElement = parseInt(RegExp.$1);

    var parent = document.getElementById("list");
    for (var i in evtdata)
    {
        if (i in Array.prototype)
            continue;
        var el = document.createElement("div");
        el.className = "eventitem" + ((i % 2 == 0) ? "even" : "");
        el.setAttribute("name", i);
        var s = "<div  style=\"float:right;color:#000000;padding:3px\">" + (parseInt(i) + 1) + "</div><b style=\"cursor:pointer\">" + tl("events.item") + " " + ReasonToString(evtdata[i].ReasonType) + " L" + evtdata[i].phase + "</b><br>";
        s += timestrActual(evtdata[i].StartTime) + " " + readableSeconds(evtdata[i].StopTime - evtdata[i].StartTime);
        el.innerHTML = s;
        el.onclick = eventlist_click;
        parent.appendChild(el);

        if (i == SelectElement) {
            // Fake Event in order to populate Table Info on startup
            var fakeevent = {'target': el};
            eventlist_click(fakeevent);
        }
    }
	
	//Fake last item
	i++;
	var listitem = tl("event.endmessage");
	var el = document.createElement("div");
	el.className = "eventitem" + ((i % 2 == 0) ? "even" : "");
	el.setAttribute("name", i);
	el.innerHTML = listitem;
	$("#list").append(el);

    if (evtdata.length === 0) {
        console.log("No events available");
        var el = document.createElement("div");
        el.className = "eventitem" + ((i % 2 === 0) ? "even" : "");
        el.setAttribute("name", 0);
        var s = "<div style=\"float:right;color:#000000;padding:3px\">0</div><b style=\"cursor:pointer\">No events available</b>";
        el.innerHTML = s;
        parent.appendChild(el);
        $("#loader").hide();
    }

}

//////////////////////////////////
// FUNC: eventlist_click
// DESC: Triggers when clicked on an event
/////////////////////////////////
function eventlist_click(evt) {

    console.log('Op event geklikt');
    if (locked) {
        alert(tl("event.wait"));
    } else {
        locked = true;
        $("#eventgraph").empty();
        $("#overviewLegend").empty();
        $("#loader").show();
        
        evt = (evt) ? evt : ((window.event) ? window.event : "");
        var elem = evt.target;
        var iHWW = parseInt(elem.getAttribute("Name"));
        if(isNaN(iHWW)){
            elem = evt.target.parentNode;
            iHWW = parseInt(elem.getAttribute("Name"));
        }

        if (SelectedEventElement) {
            removeStyleClass(SelectedEventElement, "eventitem_selected");
        }

        fillspan("info_starttime", timestrActual(evtdata[iHWW].StartTime));
        fillspan("info_duration", readableSeconds(evtdata[iHWW].StopTime - evtdata[iHWW].StartTime));
        fillspan("info_phase", "L" + evtdata[iHWW].phase);
        fillspan("info_bound", String(evtdata[iHWW].Bound).replace(/\./, getDecimalPoint()) + " " + evtdata[iHWW].unit);
        fillspan("info_maxval", String(evtdata[iHWW].maxval).replace(/\./, getDecimalPoint()) + " " + evtdata[iHWW].unit);
        fillspan("info_minval", String(evtdata[iHWW].minval).replace(/\./, getDecimalPoint()) + " " + evtdata[iHWW].unit);
        fillspan("info_avg", String(evtdata[iHWW].avg).replace(/\./, getDecimalPoint()) + " " + evtdata[iHWW].unit);
        fillspan("info_reason", ReasonToString(evtdata[iHWW].ReasonType));

        //Grafieklijnen (HWW's) zoeken bij event
        graphs = FindHwwForEvent(evtdata[iHWW]);
        graphs.sort(resultsort);

        var channel = GetChannel(evtdata[iHWW].ReasonType, evtdata[iHWW].phase);

        graphdata = {};
        GetGraphData(channel);

        addStyleClass(elem, "eventitem_selected");
        SelectedEventElement = elem;
    }
}

function GetChannel(reasontype, phase) {
    //0 = voltage L1
    //1 = current L1
    //CURRENT
    if (reasontype === 3) {
        if (phase === 1) {
            return 1;
        }
        if (phase === 2) {
            return 3;
        }
        if (phase === 3) {
            return 5;
        }
        if (phase === 4) {
            return 7;
        }
    } else {
        if (phase === 1) {
            return 0;
        }
        if (phase === 2) {
            return 2;
        }
        if (phase === 3) {
            return 4;
        }
        if (phase === 4) {
            return 6;
        }
    }
}

//////////////////////////////////
// FUNC: GetGraphData
// DESC: Loops through the available graphs for the selected event and downloads the data
/////////////////////////////////
function GetGraphData(channel) {
    var graphcount = graphs.length;

    //set all options to disabled and unchecked;
    $('#U1').prop("disabled", true).prop("checked", false);
    $('#U2').prop("disabled", true).prop("checked", false);
    $('#U3').prop("disabled", true).prop("checked", false);
    $('#U4').prop("disabled", true).prop("checked", false);
    $('#I1').prop("disabled", true).prop("checked", false);
    $('#I2').prop("disabled", true).prop("checked", false);
    $('#I3').prop("disabled", true).prop("checked", false);
    $('#I4').prop("disabled", true).prop("checked", false);
	
	var foundphasegraph = false;
	
    //CHECK IF THERE ARE ANY GRAPHS
    if (graphcount === 0) {
        $("#eventgraph").empty();
        $("#eventgraph").html("<div style='text-align: center;padding-top: 75px;'>" + tl("event.nodata") + "</div>");
        $("#loader").hide();

        locked = false;
    } else {

        //loop through availabe graphs
        for (var x in graphs)
        {

            if (hwwdata[graphs[x]].Channel === 0) {
                $('#U1').prop("disabled", false);
            }
            ;
            if (hwwdata[graphs[x]].Channel === 2) {
                $('#U2').prop("disabled", false);
            }
            ;
            if (hwwdata[graphs[x]].Channel === 4) {
                $('#U3').prop("disabled", false);
            }
            ;
            if (hwwdata[graphs[x]].Channel === 6) {
                $('#U4').prop("disabled", false);
            }
            ;
            if (hwwdata[graphs[x]].Channel === 1) {
                $('#I1').prop("disabled", false);
            }
            ;
            if (hwwdata[graphs[x]].Channel === 3) {
                $('#I2').prop("disabled", false);
            }
            ;
            if (hwwdata[graphs[x]].Channel === 5) {
                $('#I3').prop("disabled", false);
            }
            ;
            if (hwwdata[graphs[x]].Channel === 7) {
                $('#I4').prop("disabled", false);
            }
            ;

            //if this is the channel where the event occured
            if (hwwdata[graphs[x]].Channel === channel) {
				
				foundphasegraph = true;

                if (hwwdata[graphs[x]].Channel === 0) {
                    $('#U1').prop("checked", true);
                }
                ;
                if (hwwdata[graphs[x]].Channel === 2) {
                    $('#U2').prop("checked", true);
                }
                ;
                if (hwwdata[graphs[x]].Channel === 4) {
                    $('#U3').prop("checked", true);
                }
                ;
                if (hwwdata[graphs[x]].Channel === 6) {
                    $('#U4').prop("checked", true);
                }
                ;
                if (hwwdata[graphs[x]].Channel === 1) {
                    $('#I1').prop("checked", true);
                }
                ;
                if (hwwdata[graphs[x]].Channel === 3) {
                    $('#I2').prop("checked", true);
                }
                ;
                if (hwwdata[graphs[x]].Channel === 5) {
                    $('#I3').prop("checked", true);
                }
                ;
                if (hwwdata[graphs[x]].Channel === 7) {
                    $('#I4').prop("checked", true);
                }
                ;
                
                //reset 
                graphcnt = 0;
                graphdata = {};
                realgraphdata = {};
                
                $.getJSON("../../lib/events/mk_hww.html?_hww_nr=" + graphs[x], function (data) {
                    //add graphdata to the array
                    graphdata[0] = data;
                    graphdata[0]['channel'] = channel;
                    //add the label to the array
                    graphdata[0]['label'] = getChannelName(channel);
                    //check if voltage or current

                    if (channel === 1 || channel === 3 || channel === 5 || channel === 7) {
                        graphdata[0]['yaxis'] = 2;
                    }

                    realgraphdata[0] = graphdata[0];

                    showhww();
                    
                });
            }
            ;
        };
		
		if(!foundphasegraph){
			$("#eventgraph").empty();
			$("#eventgraph").html("<div style='text-align: center;padding-top: 75px;'>" + tl("event.nodata") + "</div>");
			$("#loader").hide();
			locked = false;
		}
    }
}

function fillspan(id, txt) {
    var obj = document.getElementById(id);
    if (obj)
        obj.innerHTML = txt;
}

function FindHwwForEvent(Event) {
    var list = [];
    for (var i in hwwdata) {
        if (i in Array.prototype) {
            continue;
        }
        if (Event.StartTime < hwwdata[i].StopTime && Event.StopTime > hwwdata[i].StartTime) {
            list.push(parseInt(i));
        }
    }
    return list;
}

function Events_click(evt) {
    evt = (evt) ? evt : ((window.event) ? window.event : "");
    var elem = (evt.target) ? evt.target : evt.srcElement;
    document.location.href = "info_events.html?show=" + elem.getAttribute("alt");
}

function readableSeconds(s)
{

    if (s > 60 * 60) {
        var h = Math.floor(s / (60 * 60));
        var m = Math.floor(s / 60) - h * 60;
        var sec = Math.runde((s - (h * 60 * 60 + m * 60)), 2);
        return  h + "h " + m + "m " + sec + "s";
    }
    if (s > 60) {
        var m = Math.floor(s / (60));
        var sec = Math.runde((s - m * 60), 2);
        return m + "m " + sec + "s";
    }

    return Math.runde(s, 2) + "s";
}

function showhww() {

    var i = 0;

    $("#loader").hide();
    locked = false;
    var container = document.getElementById('eventgraph');
    var d1 = [];
    var i, graph;

    var options = {
        linewidth: 1,
        xaxis: {
            minorTickFreq: 4,
            mode: "time",
            timeMode: "local",
            timeUnit: 'second'
        },
        yaxis: {
            tickFormatter: function (val, axis) {
                return val + "V";
            },
            autoscale: true
        },
        y2axis: {
            tickFormatter: function (val, axis) {
                return val + "A";
            },
            autoscale: true
        },
        grid: {
            minorVerticalLines: true
        },
        mouse: {
            track: true,
            relative: true,
            sensibility: 10,
            radius: 5,
            trackFormatter: function (obj) {

                var time = new Date(obj.nearest.x * 1000);
                var val = obj.nearest.series.label;
                var unit = "";
                if (obj.series.yaxis.n === 1) {
                    unit = "V"
                } else {
                    unit = "A"
                }

                return val + ', X: ' + dateFormat(time, "HH:MM:ss.l") + ', Y: ' + obj.y + unit;
            }
        },
        selection: {
            mode: 'x',
            fps: 30
        }, legend: {
            position: 'se'
        }
    };


    /// Draw graph with default options, overwriting with passed options
    function drawGraph(opts) {

        var data = realgraphdata;

        // Clone the options, so the 'options' variable always keeps intact.
        var o = Flotr._.extend(Flotr._.clone(options), opts || {});

        // Return a new graph.
        return Flotr.draw(container, data, o);
    }

    // Actually draw the graph.
    drawGraph();

    // Hook into the 'flotr:select' event.
    Flotr.EventAdapter.observe(container, 'flotr:select', function (area) {

        // Draw graph with new area
        graph = drawGraph({
            xaxis: {
                min: area.x1,
                max: area.x2,
                minorTickFreq: 4,
                mode: "time",
                timeMode: "local",
                timeUnit: 'second'
            },
            yaxis: {
                min: area.y1,
                max: area.y2,
                tickFormatter: function (val, axis) {
                    return val + "V";
                },
                autoscale: true
            }
        });
    });

    // When graph is clicked, draw the graph with default area.
    Flotr.EventAdapter.observe(container, 'flotr:click', function () {
        drawGraph();
    });

}

function resultsort(a, b) {
    var as = getChannelName(hwwdata[a].Channel);
    var bs = getChannelName(hwwdata[b].Channel);
    if (as[0] == bs[0]) {
        return hwwdata[a].Channel > hwwdata[b].Channel;
    } else {
        return (as[0] != 'U') ? 1 : -1;
    }
}





function HexToPhase(i) {
    if (i === 1)
        return 1;
    if (i === 2)
        return 2;
    if (i === 4)
        return 3;
    if (i === 8)
        return 4;
}

function getChannelName(i) {
    switch (i) {
        case 0:
            return tl("menu.voltage") + " " + tl("L1");
        case 1:
            return tl("menu.current") + " " + tl("L1");
        case 2:
            return tl("menu.voltage") + " " + tl("L2");
        case 3:
            return tl("menu.current") + " " + tl("L2");
        case 4:
            return tl("menu.voltage") + " " + tl("L3");
        case 5:
            return tl("menu.current") + " " + tl("L3");
        case 6:
            return tl("menu.voltage") + " " + tl("L4");
        case 7:
            return tl("menu.current") + " " + tl("L4");
        default:
            return i;
    }
}

function ReasonAndPhaseToString(reason, phase) {
    var s = "";
    if (reason == REASON_UMAX)
        return "UL" + phase;
    if (reason == REASON_UMIN)
        return "UL" + phase;
    if (reason == REASON_IMAX)
        return "IL" + phase;
    if (reason == REASON_UOFF)
        return "UL" + phase;
    return "(unkown)";
}
function ReasonToString(re) {
    if (re == REASON_UMAX)
        return tl("events.overvoltage");
    if (re == REASON_UMIN)
        return tl("events.undervoltage");
    if (re == REASON_IMAX)
        return tl("events.overcurrent");
    if (re == REASON_UOFF)
        return tl("events.voltageoff");
    return re + "(unkown)";
}

function evtsort(a, b) {
    return  b.StartTime - a.StartTime;
}


function informUser(reason) {
    var ret = null;
    if (reason == "NEW_EVT")
        ret = confirm(tl("evthww.newvalues"));
    if (reason == "NEW_TRANS")
        ret = confirm(tl("trans.newvalues"));
    if (ret)
        document.location.reload();
}
function poll_counters_callback(ResponseText) {
    var obj = eval("(" + ResponseText + ")");

    if (counter["_evt_count"] != obj["_EVT_COUNT"][0] && (SITE == "HWW" || SITE == "EVT"))
        informUser("NEW_EVT");


    if (counter["_trans_count"] != obj["_TRANS_COUNT"][0] && SITE == "TRNS") {
        informUser("NEW_TRANS");
    }

    setTimeout("poll_counters()", COUNTER_POLL_INTERVAL_MS);
}
function poll_counters() {
    $.get("json.do?_evt_count,_trans_count", poll_counters_callback);
}
iListScroll = null;
function fadein() {
    ById("graphimg").src = ById("imgpreload").src
}
function imgready() {
    //ById("imageloaderani").style.visibility="hidden";
}
function InitTransData() {
    //Fetch Data from UMG BasicPrg. async
    $.get("/lib/events/hww.html", DataReceive);
    //setTimeout("poll_counters()",COUNTER_POLL_INTERVAL_MS);
    //addEvent(document.getElementById("graphimg"),"load",imgready);
}

function timestrActual(i) {
    var DAYLENGTH = 24 * 60 * 60 * 1000; //24h in ms
    var past = new Date(i * 1000);
    var now = new Date();
    var tomorrowMidnight = new Date(now.getFullYear(), now.getMonth(), now.getDate() + 1);
    var todayMidnight = new Date(now.getFullYear(), now.getMonth(), now.getDate());
    var yesterdayMidnight = new Date(now.getFullYear(), now.getMonth(), now.getDate() - 1);

    //Today?

    if (past >= todayMidnight && past < tomorrowMidnight) {
        return tl("info.time.today") + ", " + PadZeros(past.getHours(), 2) + ":" + PadZeros(past.getMinutes(), 2) + ":" + PadZeros(past.getSeconds(), 2);
    }
    //Yesterday?
    if (past >= yesterdayMidnight && past < todayMidnight) {
        return tl("info.time.yesterday") + ", " + PadZeros(past.getHours(), 2) + ":" + PadZeros(past.getMinutes(), 2) + ":" + PadZeros(past.getSeconds(), 2);
    }
    return new Date(i * 1000).toLocaleString();
}


function ById(id) {
    return document.getElementById(id);
}

function addStyleClass(elem, cssClassName) {

    if (elem.className.indexOf(cssClassName) < 0)
        elem.className += " " + cssClassName;
}


function removeStyleClass(elem, cssClassName) {
    elem.className = elem.className.replace(cssClassName, "");
}

function PadZeros(i, len) {
    var s = i.toString();
    var erg = "";
    for (var d = 0; d < len - s.length; d++)
        erg += "0";
    return erg + s;

}



