var graphdata = {};
var graphs = null;
var graphcnt = 0;
var realgraphdata = {};
var hwwdata = null;
var SelectedEventElement = null;
var locked = false;
var REASON_UMAX = 1;
var REASON_UMIN = 2;
var REASON_IMAX = 3;
var REASON_UOFF = 4;
var graphcolor =  ['#FF0000', '#0000FF', '#FFFF00', '#FFFFF0', '#FFFFFF'];
var channelcolor = ['#FF0000', '#0000FF', '#FFF000', '#229954', '#8E44AD', '#DC7633', '#85C1E9', '#95A5A6', '#ffffff', '#ffffff', '#ffffff', '#ffffff', '#ffffff', '#ffffff', '#ffffff', '#ffffff', '#cc9900', '#00b050', '#000000'];
var checkboxIds = ['#colorboxUL1', '#colorboxIL1', '#colorboxUL2', '#colorboxIL2', '#colorboxUL3', '#colorboxIL3', '#colorboxUL4', '#colorboxIL4', '', '', '', '', '', '', '', '', '#colorboxULL1', '#colorboxULL2', '#colorboxULL3'];
var ChannelName = {};

//////////////////////////////////
// FUNC: INIT
// DESC: Initalisation
/////////////////////////////////
function initevents() {

	ById("divU1").innerHTML = tl("_ULN[0]");
	ById("divU2").innerHTML = tl("_ULN[1]");
	ById("divU3").innerHTML = tl("_ULN[2]");

	$.get("/lib/events/hww.html", DataReceive);

	$('input:checkbox').change(
		function () {
			$("#loader").show();
			locked = true;
            if ($(this).is(':checked')) {
                AddGraph($(this).val());
                $(checkboxIds[$(this).val()]).css("visibility", "visible");
            } else {
                UpdateRealGraph();
                $(checkboxIds[$(this).val()]).css("visibility", "hidden");
            }
		});
}

function AddGraph(channel) {
    
    channel = parseInt(channel);
    console.log("Addgraph with channel: " + channel);
    //check if it's allready available
    var art = false;
    for (var x in graphdata) {
        if (graphdata[x].channel === parseInt(channel)) {
            art = true;
        }
    }

    //if it is not there go get it
    if (art === false) {
        console.log("Graph is not available yet");
        //loop through availabe graphs
        for (var x in graphs)
        {
            //if this is the channel where the event occured
            console.log(hwwdata[graphs[x]].Channel);
            if (hwwdata[graphs[x]].Channel === parseInt(channel)) {
                console.log("Request channel data");
                $.getJSON("../../lib/events/mk_hww.html?_hww_nr=" + graphs[x], function (data) {
                    graphcnt++;
                    //add graphdata to the array
                    graphdata[graphcnt] = data;
                    graphdata[graphcnt]['channel'] = parseInt(channel);
                    //add the label to the array					
                    graphdata[graphcnt]['label'] = ChannelName[channel];
                    //check if voltage or current

                    if (channel & 1) {
                        graphdata[graphcnt]['yaxis'] = 2;
                    }
                    UpdateRealGraph();
                });
            }
        }
    } else {
        //update realgraphdata
        UpdateRealGraph();
    }
}

function UpdateRealGraph() {
    console.log("Update real graphs");
    realgraphdata = {};
    var gdc = 0;
		
    for (var x in graphdata) {
        if (graphdata[x].channel === 0 && $('#U1').is(':checked')) {
            realgraphdata[gdc] = graphdata[x];
			graphcolor[gdc] = channelcolor[0];
            gdc++;
        }
        if (graphdata[x].channel === 2 && $('#U2').is(':checked')) {
            realgraphdata[gdc] = graphdata[x];
			graphcolor[gdc] = channelcolor[2];
            gdc++;
        }
        if (graphdata[x].channel === 4 && $('#U3').is(':checked')) {
            realgraphdata[gdc] = graphdata[x];
			graphcolor[gdc] = channelcolor[4];
            gdc++;
        }
        if (graphdata[x].channel === 6 && $('#U4').is(':checked')) {
            realgraphdata[gdc] = graphdata[x];
			graphcolor[gdc] = channelcolor[6];
            gdc++;
        }
        if (graphdata[x].channel === 1 && $('#I1').is(':checked')) {
            realgraphdata[gdc] = graphdata[x];
			graphcolor[gdc] = channelcolor[1];
            gdc++;
        }
        if (graphdata[x].channel === 3 && $('#I2').is(':checked')) {
            realgraphdata[gdc] = graphdata[x];
			graphcolor[gdc] = channelcolor[3];
            gdc++;
        }
        if (graphdata[x].channel === 5 && $('#I3').is(':checked')) {
            realgraphdata[gdc] = graphdata[x];
			graphcolor[gdc] = channelcolor[5];
            gdc++;
        }
        if (graphdata[x].channel === 7 && $('#I4').is(':checked')) {
            realgraphdata[gdc] = graphdata[x];
			graphcolor[gdc] = channelcolor[7];
            gdc++;
        }
        
    }
    
    console.log(graphdata);
    console.log(realgraphdata);	
	
    showhww();
}

//////////////////////////////////
// FUNC: DataReceive
// DESC: Creates Event List
/////////////////////////////////
function DataReceive(text) {

    var data = text.split("-NEXT_ARRAY-");
    hwwdata = eval("(" + data[0] + ")");
    evtdata = eval("(" + data[1] + ")");
    evtdata.sort(evtsort);	
	
    for (var i in evtdata) {
        if (i in Array.prototype)
            continue;	
		
        var tmp = evtdata[i].reason >> 8 & 0x80;
        if (tmp) {						
			evtdata[i].u_relevant = (evtdata[i].reason >> 14) & 0x1;
		} else {
			evtdata[i].u_relevant = 0;
		}
		
        // Umax?
        var tmp = evtdata[i].reason >> 0 & 0x0F;
        if (tmp) {
            evtdata[i].unit = "V";
            evtdata[i].ReasonType = REASON_UMAX;
            evtdata[i].phase = HexToPhase(tmp);
        }
        //Umin?
        var tmp = evtdata[i].reason >> 8 & 0x0F;
        if (tmp) {					
            evtdata[i].unit = "V";
            evtdata[i].ReasonType = REASON_UMIN;
            evtdata[i].phase = HexToPhase(tmp);
        }
        var tmp = evtdata[i].reason >> 16 & 0x0F;
        if (tmp) {
            evtdata[i].unit = "A";
            evtdata[i].ReasonType = REASON_IMAX;
            evtdata[i].phase = HexToPhase(tmp);
        }
        var tmp = evtdata[i].reason >> 24 & 0x0F;
        if (tmp) {
            evtdata[i].unit = "V";
            evtdata[i].ReasonType = REASON_UOFF;
            evtdata[i].phase = HexToPhase(tmp);
        }
		
		if (evtdata[i].unit=="V") {
			if (evtdata[i].u_relevant==1) {
				switch(evtdata[i].phase) {
					case 1: evtdata[i].phase_str = "L1-L2"
							break;
					case 2: evtdata[i].phase_str = "L2-L3"
							break;
					case 3: evtdata[i].phase_str = "L3-L1"
							break;
					case 4: evtdata[i].phase_str = "L4"
							break;
				}
				
			} else {
				evtdata[i].phase_str = "L"+evtdata[i].phase;
			}
		} else {
			evtdata[i].phase_str = "L"+evtdata[i].phase;
		}
		
    }

    var SelectElement = 0;
    if (/show=([0-9]+)/.exec(document.location.search))
        SelectElement = parseInt(RegExp.$1);

    var parent = document.getElementById("list");
    for (var i in evtdata)
    {
        if (i in Array.prototype)
            continue;
        var el = document.createElement("div");
        el.className = "eventitem" + ((i % 2 == 0) ? "even" : "");
        el.setAttribute("name", i);
        var s = "<div  style=\"float:right;color:#000000;padding:3px\">" + (parseInt(i) + 1) + "</div><b style=\"cursor:pointer\">" + tl("events.item") + " " + ReasonToString(evtdata[i].ReasonType) +" "+ evtdata[i].phase_str + "</b><br>";
        s += toDeviceTimeString(evtdata[i].StartTime / 1000) + " " + readableSeconds(evtdata[i].StopTime / 1000 - evtdata[i].StartTime / 1000);
        el.innerHTML = s;
        el.onclick = eventlist_click;
        parent.appendChild(el);

        if (i == SelectElement) {
            // Fake Event in order to populate Table Info on startup
            var fakeevent = {'target': el};
            eventlist_click(fakeevent);
        }
    }
	
	//Fake last item
	i++;
	var listitem = tl("event.endmessage");
	var el = document.createElement("div");
	el.className = "eventitem" + ((i % 2 == 0) ? "even" : "");
	el.setAttribute("name", i);
	el.innerHTML = listitem;
	$("#list").append(el);

    if (evtdata.length === 0) {
        console.log("No events available");
        var el = document.createElement("div");
        el.className = "eventitem" + ((i % 2 === 0) ? "even" : "");
        el.setAttribute("name", 0);
        var s = "<div style=\"float:right;color:#000000;padding:3px\">0</div><b style=\"cursor:pointer\">No events available</b>";
        el.innerHTML = s;
        parent.appendChild(el);
        $("#loader").hide();
    }

}

//////////////////////////////////
// FUNC: eventlist_click
// DESC: Triggers when clicked on an event
/////////////////////////////////
function eventlist_click(evt) {
    clearColorboxes();
    console.log('Op event geklikt');
    if (locked) {
        alert(tl("event.wait"));
    } else {
        locked = true;
        $("#eventgraph").empty();
        $("#overviewLegend").empty();
        $("#loader").show();
        
        evt = (evt) ? evt : ((window.event) ? window.event : "");
        var elem = evt.target;
        var iHWW = parseInt(elem.getAttribute("Name"));
        if(isNaN(iHWW)){
            elem = evt.target.parentNode;
            iHWW = parseInt(elem.getAttribute("Name"));
        }

        if (SelectedEventElement) {
            removeStyleClass(SelectedEventElement, "eventitem_selected");
        }
 
        fillspan("info_starttime", toDeviceTimeString(evtdata[iHWW].StartTime / 1000));
        fillspan("info_duration", readableSeconds(evtdata[iHWW].StopTime / 1000 - evtdata[iHWW].StartTime / 1000));
        fillspan("info_phase", "L" + evtdata[iHWW].phase);
        fillspan("info_bound", String(evtdata[iHWW].Bound).replace(/\./, getDecimalPoint()) + " " + evtdata[iHWW].unit);
        fillspan("info_maxval", String(evtdata[iHWW].maxval).replace(/\./, getDecimalPoint()) + " " + evtdata[iHWW].unit);
        fillspan("info_minval", String(evtdata[iHWW].minval).replace(/\./, getDecimalPoint()) + " " + evtdata[iHWW].unit);
        fillspan("info_avg", String(evtdata[iHWW].avg).replace(/\./, getDecimalPoint()) + " " + evtdata[iHWW].unit);
        fillspan("info_reason", ReasonToString(evtdata[iHWW].ReasonType));

        //Grafieklijnen (HWW's) zoeken bij event
        graphs = FindHwwForEvent(evtdata[iHWW]);
        graphs.sort(resultsort);

        if (evtdata[iHWW].u_relevant) {			
			ById("divU1").innerHTML = tl("_ULL[0]");
			ById("divU2").innerHTML = tl("_ULL[1]");
			ById("divU3").innerHTML = tl("_ULL[2]");
		} else {
			ById("divU1").innerHTML = tl("_ULN[0]");
			ById("divU2").innerHTML = tl("_ULN[1]");
			ById("divU3").innerHTML = tl("_ULN[2]");
		}
		
		setChannelName(evtdata[iHWW].u_relevant);
		
        var channel = GetChannel(evtdata[iHWW].ReasonType, evtdata[iHWW].phase);
        graphdata = {};
        GetGraphData(channel,evtdata[iHWW].StartTime / 1000) ;

        addStyleClass(elem, "eventitem_selected");
        SelectedEventElement = elem;
    }
}

function GetChannel(reasontype, phase) {
    //0 = voltage L1
    //1 = current L1
    //CURRENT
    if (reasontype === 3) {
		return (phase * 2) - 1; 
	} else {
		return (phase - 1) * 2; 
	}
}

//////////////////////////////////
// FUNC: GetGraphData
// DESC: Loops through the available graphs for the selected event and downloads the data
/////////////////////////////////
function GetGraphData(channel,starttime) {
    var graphcount = graphs.length;

    //set all options to disabled and unchecked;
    $('#U1').prop("disabled", true).prop("checked", false);
    $('#U2').prop("disabled", true).prop("checked", false);
    $('#U3').prop("disabled", true).prop("checked", false);
    $('#U4').prop("disabled", true).prop("checked", false);
    $('#I1').prop("disabled", true).prop("checked", false);
    $('#I2').prop("disabled", true).prop("checked", false);
    $('#I3').prop("disabled", true).prop("checked", false);
    $('#I4').prop("disabled", true).prop("checked", false);
	
	var foundphasegraph = false;
	
    //CHECK IF THERE ARE ANY GRAPHS
    if (graphcount === 0) {
        $("#eventgraph").empty();
        $("#eventgraph").html("<div style='text-align: center;padding-top: 75px;'>" + tl("event.nodata") + "</div>");
        $("#loader").hide();

        locked = false;
    } else {
        //loop through availabe graphs
        for (var x in graphs)
        {

            if (hwwdata[graphs[x]].Channel === 0) {
                $('#U1').prop("disabled", false);
            }
            ;
            if (hwwdata[graphs[x]].Channel === 2) {
                $('#U2').prop("disabled", false);
            }
            ;
            if (hwwdata[graphs[x]].Channel === 4) {
                $('#U3').prop("disabled", false);
            }
            ;
            if (hwwdata[graphs[x]].Channel === 6) {
                $('#U4').prop("disabled", false);
            }
            ;
            if (hwwdata[graphs[x]].Channel === 1) {
                $('#I1').prop("disabled", false);
            }
            ;
            if (hwwdata[graphs[x]].Channel === 3) {
                $('#I2').prop("disabled", false);
            }
            ;
            if (hwwdata[graphs[x]].Channel === 5) {
                $('#I3').prop("disabled", false);
            }
            ;
            if (hwwdata[graphs[x]].Channel === 7) {
                $('#I4').prop("disabled", false);
            }
            ;

            //if this is the channel where the event occured
            if (hwwdata[graphs[x]].Channel === channel) {
				
				foundphasegraph = true;

                if (hwwdata[graphs[x]].Channel === 0) {
                    $('#U1').prop("checked", true);
                }
                ;
                if (hwwdata[graphs[x]].Channel === 2) {
                    $('#U2').prop("checked", true);
                }
                ;
                if (hwwdata[graphs[x]].Channel === 4) {
                    $('#U3').prop("checked", true);
                }
                ;
                if (hwwdata[graphs[x]].Channel === 6) {
                    $('#U4').prop("checked", true);
                }
                ;
                if (hwwdata[graphs[x]].Channel === 1) {
                    $('#I1').prop("checked", true);
                }
                ;
                if (hwwdata[graphs[x]].Channel === 3) {
                    $('#I2').prop("checked", true);
                }
                ;
                if (hwwdata[graphs[x]].Channel === 5) {
                    $('#I3').prop("checked", true);
                }
                ;
                if (hwwdata[graphs[x]].Channel === 7) {
                    $('#I4').prop("checked", true);
                }
                ;
                
                //reset 
                graphcnt = 0;
                graphdata = {};
                realgraphdata = {};
                $(checkboxIds[channel]).css("visibility", "visible");
                $.getJSON("../../lib/events/mk_hww.html?_hww_nr=" + graphs[x] + "&_hww_start=" + starttime, function (data) {
                    //add graphdata to the array
                    graphdata[0] = data;
                    graphdata[0]['channel'] = channel;
                    //add the label to the array
                    graphdata[0]['label'] = ChannelName[channel];
                    //check if voltage or current

                    if (channel & 1) {
                        graphdata[0]['yaxis'] = 2;
                    }

                    realgraphdata[0] = graphdata[0];
					UpdateRealGraph();
                });
            }
            ;
        };
		
		if(!foundphasegraph){
			$("#eventgraph").empty();
			$("#eventgraph").html("<div style='text-align: center;padding-top: 75px;'>" + tl("event.nodata") + "</div>");
			$("#loader").hide();
			locked = false;
		}
    }
}

function fillspan(id, txt) {
    var obj = document.getElementById(id);
    if (obj)
        obj.innerHTML = txt;
}

function FindHwwForEvent(Event) {
    var list = [];
    for (var i in hwwdata) {
        if (i in Array.prototype) {
            continue;
        }
        if (Event.StartTime < hwwdata[i].StopTime && Event.StartTime > hwwdata[i].StartTime) {
            list.push(parseInt(i));
        }
    }
    return list;
}

function Events_click(evt) {
    evt = (evt) ? evt : ((window.event) ? window.event : "");
    var elem = (evt.target) ? evt.target : evt.srcElement;
    document.location.href = "info_events.html?show=" + elem.getAttribute("alt");
}

function readableSeconds(s)
{

    if (s > 60 * 60) {
        var h = Math.floor(s / (60 * 60));
        var m = Math.floor(s / 60) - h * 60;
        var sec = Math.runde((s - (h * 60 * 60 + m * 60)), 2);
        return  h + "h " + m + "m " + sec + "s";
    }
    if (s > 60) {
        var m = Math.floor(s / (60));
        var sec = Math.runde((s - m * 60), 2);
        return m + "m " + sec + "s";
    }

    return Math.runde(s, 2) + "s";
}

function showhww() {

    var i = 0;

    $("#loader").hide();
    locked = false;
    var container = document.getElementById('eventgraph');
    var d1 = [];
    var i, graph;

    var options = {
        linewidth: 1,
        xaxis: {
            tickFormatter: function (val, axis) {
                return dateFormat(getFakedLocalDeviceTime(val), "HH:MM:ss");
            },
            autoscale: false
        },
        yaxis: {
            tickFormatter: function (val, axis) {
                return val + "V";
            },
            autoscale: true
        },
        y2axis: {
            tickFormatter: function (val, axis) {
                return val + "A";
            },
            autoscale: true
        },
        grid: {
            minorVerticalLines: true
        },
        mouse: {
            track: true,
            relative: true,
            sensibility: 10,
            radius: 5,
            trackFormatter: function (obj) {

                var time = getFakedLocalDeviceTime(obj.nearest.x);
                var val = obj.nearest.series.label;
                var unit = "";
                if (obj.series.yaxis.n === 1) {
                    unit = "V"
                } else {
                    unit = "A"
                }

                return val + ', X: ' + dateFormat(time, "HH:MM:ss.l") + ', Y: ' + obj.y + unit;
            }
        },
        selection: {
            mode: 'x',
            fps: 30
        }, legend: {
            position: 'se'
        }
    };


    /// Draw graph with default options, overwriting with passed options
    function drawGraph(opts) {

        var data = realgraphdata;

        // Clone the options, so the 'options' variable always keeps intact.
        var o = Flotr._.extend(Flotr._.clone(options), opts || {});

		o.colors = graphcolor;
        // Return a new graph.
        return Flotr.draw(container, data, o);
    }

    // Actually draw the graph.
    drawGraph();

    // Hook into the 'flotr:select' event.
    Flotr.EventAdapter.observe(container, 'flotr:select', function (area) {

        // Draw graph with new area
        graph = drawGraph({
            xaxis: {
                min: area.x1,
                max: area.x2,
                minorTickFreq: 4,
                mode: "time",
                timeMode: "local",
                timeUnit: 'second'
            },
            yaxis: {
                min: area.y1,
                max: area.y2,
                tickFormatter: function (val, axis) {
                    return val + "V";
                },
                autoscale: true
            }
        });
    });

    // When graph is clicked, draw the graph with default area.
    Flotr.EventAdapter.observe(container, 'flotr:click', function () {
        drawGraph();
    });

}

function resultsort(a, b) {
	
	if ((hwwdata[a].Channel&1) == (hwwdata[b].Channel&1) ) {
		return hwwdata[a].Channel > hwwdata[b].Channel;
	} else {
		if (hwwdata[a].Channel&1) {
			return (-1);
		}  else {
			return (1);
		}
	}
}


function HexToPhase(i) {
    if (i === 1)
        return 1;
    if (i === 2)
        return 2;
    if (i === 4)
        return 3;
    if (i === 8)
        return 4;
}

function setChannelName(u_relevant) {
    
	if (u_relevant==1) {
		ChannelName[0] = tl("menu.voltage") + " " + tl("L1-L2");
		ChannelName[2] = tl("menu.voltage") + " " + tl("L2-L3");
		ChannelName[4] = tl("menu.voltage") + " " + tl("L3-L1");
	} else {
		ChannelName[0] = tl("menu.voltage") + " " + tl("L1");
		ChannelName[2] = tl("menu.voltage") + " " + tl("L2");
		ChannelName[4] = tl("menu.voltage") + " " + tl("L3");
	}

	ChannelName[6] = tl("menu.voltage") + " " + tl("L4");

	ChannelName[1] = tl("menu.current") + " " + tl("L1");
	ChannelName[3] = tl("menu.current") + " " + tl("L2");
	ChannelName[5] = tl("menu.current") + " " + tl("L3");
	ChannelName[7] = tl("menu.current") + " " + tl("L4");
 	
}


function ReasonToString(re) {
    if (re == REASON_UMAX)
        return tl("events.overvoltage");
    if (re == REASON_UMIN)
        return tl("events.undervoltage");
    if (re == REASON_IMAX)
        return tl("events.overcurrent");
    if (re == REASON_UOFF)
        return tl("events.voltageoff");
    return re + "(unkown)";
}

function evtsort(a, b) {
    return  b.StartTime - a.StartTime;
}


function informUser(reason) {
    var ret = null;
    if (reason == "NEW_EVT")
        ret = confirm(tl("evthww.newvalues"));
    if (reason == "NEW_TRANS")
        ret = confirm(tl("trans.newvalues"));
    if (ret)
        document.location.reload();
}
function poll_counters_callback(ResponseText) {
    var obj = eval("(" + ResponseText + ")");

    if (counter["_evt_count"] != obj["_EVT_COUNT"][0] && (SITE == "HWW" || SITE == "EVT"))
        informUser("NEW_EVT");


    if (counter["_trans_count"] != obj["_TRANS_COUNT"][0] && SITE == "TRNS") {
        informUser("NEW_TRANS");
    }

    setTimeout("poll_counters()", COUNTER_POLL_INTERVAL_MS);
}
function poll_counters() {
    $.get("json.do?_evt_count,_trans_count", poll_counters_callback);
}
iListScroll = null;
function fadein() {
    ById("graphimg").src = ById("imgpreload").src
}
function imgready() {
    //ById("imageloaderani").style.visibility="hidden";
}
function InitTransData() {
    //Fetch Data from UMG BasicPrg. async
    $.get("/lib/events/hww.html", DataReceive);
    //setTimeout("poll_counters()",COUNTER_POLL_INTERVAL_MS);
    //addEvent(document.getElementById("graphimg"),"load",imgready);
}

function ById(id) {
    return document.getElementById(id);
}

function addStyleClass(elem, cssClassName) {

    if (elem.className.indexOf(cssClassName) < 0)
        elem.className += " " + cssClassName;
}


function removeStyleClass(elem, cssClassName) {
    elem.className = elem.className.replace(cssClassName, "");
}

function PadZeros(i, len) {
    var s = i.toString();
    var erg = "";
    for (var d = 0; d < len - s.length; d++)
        erg += "0";
    return erg + s;

}

setTimeout(function () {
    $('#colorboxUL1').css("background-color", channelcolor[0]);
    $('#colorboxUL2').css("background-color", channelcolor[2]);
    $('#colorboxUL3').css("background-color", channelcolor[4]);
    $('#colorboxUL4').css("background-color", channelcolor[6]);
    $('#colorboxIL1').css("background-color", channelcolor[1]);
    $('#colorboxIL2').css("background-color", channelcolor[3]);
    $('#colorboxIL3').css("background-color", channelcolor[5]);
    $('#colorboxIL4').css("background-color", channelcolor[7]);
}, 200);

clearColorboxes = () => {
    $('#colorboxUL1').css('visibility', 'hidden');
    $('#colorboxUL2').css('visibility', 'hidden');
    $('#colorboxUL3').css('visibility', 'hidden');
    $('#colorboxUL4').css('visibility', 'hidden');
    $('#colorboxIL1').css('visibility', 'hidden');
    $('#colorboxIL2').css('visibility', 'hidden');
    $('#colorboxIL3').css('visibility', 'hidden');
    $('#colorboxIL4').css('visibility', 'hidden');
}

